#ifndef _CHACHA_H_
#define _CHACHA_H_

#include <sys/time.h>
#include <time.h>

#ifdef __cplusplus
extern "C" {
#endif
  void salsa20_wordtobyte(uint8_t output[64],const uint32_t input[16]);
  void encrypt_bytes(uint32_t *x, const uint8_t *m, uint8_t *c_, uint32_t bytes);
  void keysetup(uint32_t *input, const uint8_t *k, const uint32_t kbits, const uint32_t ivbits);
  void ivsetup(uint32_t *input, const uint8_t *iv);

static inline double wallclock(void) {
  struct timeval tv;
  struct timezone tz;
  double t;
  static double tr;
  
  gettimeofday(&tv, &tz);
  if (tr == 0.)
    tr = (double) tv.tv_sec;
    
  t = (double) tv.tv_sec - (double)tr;
  t += ((double) tv.tv_usec) / 1000000.0;
  
  return t;
}

#ifdef __cplusplus
}
#endif


#endif // _CHACHA_H_
